/*	Interrupt.java
 *
 *	Example of interrupt handle for PIO-D24.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages


public class Interrupt implements IxpioIsr  				//Implement IxpioIsr interrupt class
{
	
	public void ixpio_isr(int sig)					//Will be call when trigger interrupt
	{
		System.out.println("Java get signal " + sig);
	}
	
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		Interrupt demo_isr;
		byte a[] = new byte[100];
		Ixpio icpdasio1=new Ixpio();
		fd=icpdasio1.open("ixpio2");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		/* port configuration */
		if((rev=icpdasio1.setPort(fd,"IXPIO_PC",03))!=0) System.out.println("Configure PCA Error Code:"+ rev);    
		/* Port 0/1 as DO, Port 2 as DI*/
		/* configure board interrupt */	
		demo_isr = new Interrupt();
		/* INT_CHAN_0 */
		if((rev=icpdasio1.registerInterrupt(fd, 1, 0,demo_isr))!=0) System.out.println("Reg Int Error Code : "+ rev);   /* INT_CHAN_0  signal for both edges */
		while(a[0]!=113)	/* read, get out if 'q' + Enter pressed */
		{
			System.in.read(a);
		}
		/*Remove Interrupt before program end*/
		if((rev=icpdasio1.removeInterrupt(fd))!=0) System.out.println("Remove Int Error Code : "+ rev);   /* INT_CHAN_0  signal for both edges */
		icpdasio1.close(fd);
		System.out.println("End of program");
	}
}
