/*	Interrupt.java
 *
 *	Example of interrupt handle for PIO-D96.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages


public class Interrupt implements IxpioIsr  				//Implement IxpioIsr interrupt class 
{
	static int sig_counter=0;
	public void ixpio_isr(int sig)					//Will be call when trigger interrupt
	{
		//System.out.println("Java get signal " + sig);
		System.out.print("\rGet "+ sig_counter +" signal");
		sig_counter++;
	}
	
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		Interrupt demo_isr;
		byte a[] = new byte[100];
		Ixpio icpdasio1=new Ixpio();
		fd=icpdasio1.open("ixpio2");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		/* configure ports, port 0-2 as input */
		if((rev=icpdasio1.setPort(fd,"IXPIO_PCA",03))!=0) System.out.println("Configure PCA Error Code:"+ rev);
		demo_isr = new Interrupt();
		/* INT_CHAN_0, signal for both edges*/
		if((rev=icpdasio1.registerInterrupt(fd, 1, 2,demo_isr))!=0) System.out.println("Register Int Error Code : "+rev);
		while(a[0]!=113)
		{
			System.in.read(a);
		}
		/*Remove Interrupt before program end*/
		if((rev=icpdasio1.removeInterrupt(fd))!=0) System.out.println("Revmove Int Error Code : "+rev);
		icpdasio1.close(fd);
		System.out.println("End of program");
	}
}
