/*	Ao.java
 *
 *	Example of analog output for PIO-DA16/DA8/DA4.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages

public class Ao 
{
	private static int DA_CHANNEL_0 = 0x00;	// channel 0
	private static int DA_CHANNEL_1 = 0x40;	// channel 1
	private static int DA_CHANNEL_2 = 0x80;	// channel 2
	private static int DA_CHANNEL_3 = 0xc0;	// channel 3
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		int ao_value=0;
		byte a[] = new byte[100];
		Ixpio icpdasio1=new Ixpio();
		IxpioReg aol = new IxpioReg();
		IxpioReg aoh = new IxpioReg();
		IxpioReg cs = new IxpioReg();
		cs.value = 0;
		aol.value = 0;
		aoh.value = 1;
		fd=icpdasio1.open("ixpio2");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		System.out.println("Press <enter> for next, 'q'+<enter> to exit.");
		while(a[0]!=113)
		{
			aol.value = ao_value & 0xff;
			aoh.value = (ao_value >> 8) | DA_CHANNEL_0;
			if((rev=icpdasio1.setReg(fd,"IXPIO_DAL",aol))!=0) System.out.println("Write DAL Error Code:"+ rev);
			if((rev=icpdasio1.setReg(fd,"IXPIO_DAH",aoh))!=0) System.out.println("Write DAH Error Code:"+ rev);
			if((rev=icpdasio1.setReg(fd,"IXPIO_DA0CS",cs))!=0) System.out.println("Write CS Error Code:"+ rev);
			System.out.print("Analog output : 0x"+ Integer.toHexString(aoh.value) + Integer.toHexString(aol.value) + "    <Enter> next, ESC exit ");
			System.in.read(a);
			if(ao_value == 0x3fff) ao_value = 0;
			else ao_value = (ao_value << 1) + 1 ;
		}
		icpdasio1.close(fd);
		System.out.println("End of program");		
	}

}
