/*	Ao4.java
 *
 *	Example of voltage output with calibration for PIO-DA16/DA8/DA4.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
  
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages

public class Ao4
{
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		int temp = 0;
		IxpioAio ao = new IxpioAio();
		byte a[] = new byte[100];
		Ixpio icpdasio1 = new Ixpio();
		fd=icpdasio1.open("ixpio2");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		ao.channel = 5; /* DA_1, channel 5 */
		ao.value = 0.1;
		System.out.println("Press <enter> for next, 'q'+<enter> to exit.");
		while(a[0]!=113)
		{
			if((rev=icpdasio1.setCalVoltageOut(fd,ao))!=0) System.out.println("AnalogOut Error Code:"+ rev);

			System.out.println("Calibration Voltage Output: "+ ao.value +"(V)     <Enter> next, 'q'+<enter> exit ");
			System.in.read(a);
			if(ao.value < 10) {
				ao.value = ao.value * 2;
			}
			else {
				ao.value = 0.1 ;
			}
		}
		icpdasio1.close(fd);
		System.out.println("End of program");		
	}

}
