/*	AoPatSw.java
 *
 *	Example of pattern analog output switch for PIO-DA16/DA8/DA4.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages

public class AoPatSw
{
	static int INT = 1;
	static int INT_EDGE = 1;
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		int swi = 0;
		IxpioAio ao = new IxpioAio();
		Pattern pat = new Pattern();
		int sw[] = new int[20];
		byte a[] = new byte[100];
		Ixpio icpdasio1=new Ixpio();
		fd=icpdasio1.open("ixpio1");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		System.out.println("Analog SW Press <ID Num> for switch, ESC to exit.");
		ao.id = 1;
		if((rev=icpdasio1.getAnalogOutPatStatus(fd,ao))!=0) System.out.println("AnalogStatus Error Code:"+ rev);
		sw[1] = ao.flags&1;
		ao.id = 2;
		if((rev=icpdasio1.getAnalogOutPatStatus(fd,ao))!=0) System.out.println("AnalogStatus Error Code:"+ rev);
		sw[2] = ao.flags&1;
		ao.id = 3;
		if((rev=icpdasio1.getAnalogOutPatStatus(fd,ao))!=0) System.out.println("AnalogStatus Error Code:"+ rev);
		sw[3] = ao.flags&1;
		ao.id = 4;
		if((rev=icpdasio1.getAnalogOutPatStatus(fd,ao))!=0) System.out.println("AnalogStatus Error Code:"+ rev);
		sw[4] = ao.flags&1;
		ao.id = 5;
		if((rev=icpdasio1.getAnalogOutPatStatus(fd,ao))!=0) System.out.println("AnalogStatus Error Code:"+ rev);
		sw[5] = ao.flags&1;
		while(a[0]!=113)
		{
			System.out.println(sw[1] +","+ sw[2] +","+ sw[3] +","+ sw[4] +","+ sw[5]);
			System.in.read(a);
			if (a[0]>48) swi = a[0] - 48 ;
			else swi = 0; 
			ao.id = swi;
			if (sw[swi] == 1 ) {
				sw[swi] = 0;
				if((rev=icpdasio1.setAnalogOutPatStop(fd,ao))!=0) System.out.println("AnalogOutStop Error Code:"+ rev);
				System.out.println("Analog ID : "+ swi + " OFF Press <enter> for next, 'q'+<enter> to exit.");
			}
			else {
				sw[swi] = 1;	
				if((rev=icpdasio1.setAnalogOutPatStart(fd,ao))!=0) System.out.println("AnalogOutStart Error Code:"+ rev);
				System.out.println("Analog ID : "+ swi + " ON Press <enter> for next, 'q'+<enter> to exit.");
			}
		}
		icpdasio1.close(fd);
		System.out.println("End of program");		
	}

}
