/*	Counter.java
 *
 *	Example of counter for PIO-DA16/DA8/DA4.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages

public class Counter implements IxpioIsr 
{
	static int beat = 0;
	static int INT1 = 2;
	static int INT1_NEG_EDGE = 0;
	static IxpioDio din,dout;
	static Ixpio icpdasio1;
	static int fd;
	public void ixpio_isr(int sig)
	{
		int rev;
		if ((rev=icpdasio1.setDigitalOut(fd,dout))!=0) System.out.println("DO Error");
		if ((rev=icpdasio1.getDigitalIn(fd,din))!=0) System.out.println("DO Error");
		System.out.print("\rTime beat: "+ beat + "   Digital Output: 0x"+ Integer.toHexString(dout.u16)+ "   Digital Input: 0x"+ Integer.toHexString(din.u16)+ "    <enter> exit");
		if (dout.u16 == 0x8000) dout.u16 = 1;
		else dout.u16 <<=1 ;
		beat ++;
	}
	
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		Counter demo_isr;
		byte a[] = new byte[100];
		icpdasio1 = new Ixpio();
		din = new IxpioDio();
		dout = new IxpioDio();
		fd=icpdasio1.open("ixpio2");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		din.u16 = 0;
		dout.u16 = 1;
		demo_isr = new Counter();
		/* enable INT_CHAN_1 (INT1) for interrupt */
		/* INT_CHAN_0  signal for negative edges */
		rev=icpdasio1.registerInterrupt(fd, INT1, INT1_NEG_EDGE, demo_isr);
		if(rev != 0) System.out.println("Install Interrupt Error Code:"+ rev);
		/*****************************************
	 	* setup 8254 counter-1/2 for INT_CHAN_1 *
	 	*                                       *
	 	* 4MHz / (40000 * 100) = 1Hz            *
	 	*****************************************/	
	 	/* counter-1, mode 3, 0x9c40 == 40000 */	
		rev=icpdasio1.setCounter(fd,1,0,0x76,0x9c40);
		if(rev != 0) System.out.println("Config Counter 1 Error Code:"+ rev);
		/* counter-2, mode 3 */
		rev=icpdasio1.setCounter(fd,2,0,0xb6,100);
		if(rev != 0) System.out.println("Config Counter 2Error Code:"+ rev);
		while(a[0]!=113)
		{
			System.in.read(a);
		}
		rev=icpdasio1.removeInterrupt(fd);   /* INT_CHAN_0  signal for both edges */
		if(rev != 0) System.out.println("Remove Interrupt Error Code:"+ rev);
		icpdasio1.close(fd);
		System.out.println("End of program");
	}
}
