/*	Dio.java
 *
 *	Example of Digital I/O for PIO-DA16/DA8/DA4.
 *
 *	v 0.0 2003.8.7 by moki matsushima
 *
 *	Copyright (c) 2003 ICPDAS, Inc. All  Rights Reserved.
 */
 
import java.io.*;							//For System.in.read()
import com.icpdas.cardio.ixpio.*;					//ICPDAS PIO Series I/O Card packages

public class Dio 
{
	public static void main(String[] args) throws java.io.IOException
	{
		int rev;
		int fd;
		int dinl=0,dinh=0;
		byte a[] = new byte[100];
		Ixpio icpdasio1 = new Ixpio();
		IxpioReg doutl = new IxpioReg();
		IxpioReg douth = new IxpioReg();
		doutl.value = 1;
		douth.value = 0;
		fd=icpdasio1.open("ixpio1");
		if(fd==-1) System.out.println("Card Open Error Code:"+ fd);
		while(a[0]!=113)
		{
			if((rev=icpdasio1.setReg(fd,"IXPIO_DL",doutl))!=0) System.out.println("Write DL Error Code:"+ rev);
			if((rev=icpdasio1.setReg(fd,"IXPIO_DH",douth))!=0) System.out.println("Write DH Error Code:"+ rev);

			if((dinl=icpdasio1.getReg(fd,"IXPIO_DL"))==-1) System.out.println("Read DL Error Code:"+ dinl);
			if((dinh=icpdasio1.getReg(fd,"IXPIO_DH"))==-1) System.out.println("Read DH Error Code:"+ dinh);
			System.out.println("Digital Output: 0x"+ Integer.toHexString(douth.value) +Integer.toHexString(doutl.value)+"    Input: 0x"+ Integer.toHexString(dinh)+Integer.toHexString(dinl)+"     <Enter> next, 'q'+<enter> exit ");
			System.in.read(a);
			if(doutl.value!=0){
				if(doutl.value == 0x80) {
					doutl.value = 0;
					douth.value = 1;
				}else doutl.value <<=1;
			}else if (douth.value!=0){
				if(douth.value == 0x80) {
					doutl.value = 1;
					douth.value = 0;
				}else douth.value <<=1;
			}else doutl.value = 1;
		}
		icpdasio1.close(fd);
		System.out.println("End of program");		
	}

}
